web/src/main/java/com/jaider/controladores/PrecioController.java
package com.jaider.controladores;

import java.io.Serializable;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.enterprise.context.SessionScoped;
import javax.faces.model.SelectItem;
import javax.inject.Inject;
import javax.inject.Named;

import com.jaider.utilidades.Formulario;
import com.jaider.utilidades.MostrarMensaje;
import com.jaider.utilidades.Propiedades;

import jaider.ejb.models.ListaPrecio;
import jaider.ejb.models.Precio;
import jaider.ejb.models.Producto;
import jaider.ejb.services.ServiciosBasicos;

@Named("beanPrecio")
@SessionScoped
public class PrecioController implements Serializable {

	private static final long serialVersionUID = 1L;

	private Precio objPrecio;
	private List<Precio> listadoPrecios;

	// Variables de combo
	private Integer idComboListaPrecio;
	private Integer idComboProducto;
	private List<SelectItem> listaPreciosCargada;

	@Inject
	ProductoController productController;

	@EJB
	ServiciosBasicos<Precio> servicioPrecio;

	@EJB
	ServiciosBasicos<Producto> servicioProducto;

	@EJB
	ServiciosBasicos<ListaPrecio> servicioListaPrecio;

	public PrecioController() throws Exception {
		super();
		initObject();
	}

	public void initObject() throws Exception {
		objPrecio = new Precio();
		objPrecio.setListaPrecio(new ListaPrecio());
		idComboListaPrecio = null;
		idComboProducto = null;
		getComboListaPreciosVacia();
	}

	@PostConstruct
	public void init() throws Exception {
		getComboListaPreciosVacia();
	}

	public Precio getobjPrecio() {
		return objPrecio;
	}

	public void setobjPrecio(Precio objPrecio) {
		this.objPrecio = objPrecio;
	}

	public List<Precio> getListadoPrecios() {
		listadoPreciosJPA();
		return listadoPrecios;
	}

	public void setListadoPrecios(List<Precio> listadoPrecios) {
		this.listadoPrecios = listadoPrecios;
	}

	public Precio getObjPrecio() {
		return objPrecio;
	}

	public void setObjPrecio(Precio objPrecio) {
		this.objPrecio = objPrecio;
	}

	public Integer getIdComboListaPrecio() {
		return idComboListaPrecio;
	}

	public void setIdComboListaPrecio(Integer idComboListaPrecio) {
		this.idComboListaPrecio = idComboListaPrecio;
	}

	public Integer getIdComboProducto() {
		return idComboProducto;
	}

	public void setIdComboProducto(Integer idComboProducto) {
		this.idComboProducto = idComboProducto;
	}

	public List<SelectItem> getListaPreciosCargada() {
		return listaPreciosCargada;
	}

	public void setListaPreciosCargada(List<SelectItem> listaPreciosCargada) {
		this.listaPreciosCargada = listaPreciosCargada;
	}

	public void btnCrearPrecio() {
		try {
			Producto producto = new Producto();
			producto = servicioProducto.buscar(Producto.class, idComboProducto);

			ListaPrecio listaPrecio = new ListaPrecio();
			listaPrecio = servicioListaPrecio.buscar(ListaPrecio.class, idComboListaPrecio);

			objPrecio.setProducto(producto);
			objPrecio.setListaPrecio(listaPrecio);
			objPrecio.generarPK();

			servicioPrecio.crear(objPrecio);

			initObject();

			MostrarMensaje.pantalla("precio_es_CO", "exito", "exitoCrear", "exitoCrearDetalle", "msgGrowl");

		} catch (Exception e) {
			MostrarMensaje.pantalla("precio_es_CO", "fatal", "errorCrear", "errorCrearDetalle", "msgGrowl");
		}
	}

	public List<SelectItem> getComboProducto() throws Exception {
		String mensajeVacio = Propiedades.obtener("/precio_es_CO", "selectProductoEmpty");
		List<Producto> listaProductos = servicioProducto.listarJPA(Producto.class);
		return Formulario.armarCombo(listaProductos, mensajeVacio, "getIdProducto", "getNombreProducto");
	}

	public void getComboListaPrecios() throws Exception {
		String mensajeVacio = Propiedades.obtener("/precio_es_CO", "selectListaPrecioEmpty");
		List<ListaPrecio> listaPrecios = servicioListaPrecio.listarNQUERY(ListaPrecio.class, "DISPONIBLE_POR_PRODUCTO", "codPro", idComboProducto);
		listaPreciosCargada = Formulario.armarCombo(listaPrecios, mensajeVacio, "getIdListaPrecio", "getNombreListaPrecio");
	}
	
	public void getComboListaPreciosVacia() throws Exception {
		String mensajeVacio = Propiedades.obtener("/precio_es_CO", "selectListaPrecioEmpty");
		listaPreciosCargada = Formulario.armarCombo(null, mensajeVacio, "getIdListaPrecio", "getNombreListaPrecio");
	}

	public void btnCrear() {
		try {
			objPrecio.setProducto(productController.getObjProducto());
			objPrecio.generarPK();
			
			servicioPrecio.actualizar(objPrecio);
			initObject();

			MostrarMensaje.pantalla("precio_es_CO", "exito", "exitoCrear", "exitoCrearDetalle", "msgGrowl");
		} catch (Exception e) {
			MostrarMensaje.pantalla("precio_es_CO", "fatal", "errorCrear", "errorCrearDetalle", "msgGrowl");
		}
	}

	public void btnBorrar() {
		try {
			servicioPrecio.borrar(objPrecio);

			objPrecio = new Precio();

			MostrarMensaje.pantalla("precio_es_CO", "exito", "exitoBorrar", "exitoBorrarDetalle", "msgGrowl");
		} catch (Exception e) {
			MostrarMensaje.pantalla("precio_es_CO", "fatal", "errorBorrar", "errorBorrarDetalle", "msgGrowl");
		}
	}

	public void listadoPreciosJPA() {
		try {
			listadoPrecios = servicioPrecio.listarJPA(Precio.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public List<Precio> listadoPreciosNQUERY() {
		try {
			return servicioPrecio.listarNQUERY(Precio.class, "PRODUCTOS", "codigoProducto",
					productController.getObjProducto().getIdProducto());
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	public String seleccionarPrecioActualizar(Precio temp) {
		objPrecio = temp;
		return "editar.faces";
	}

	public void seleccionarPrecioBorrar(Precio temp) {
		objPrecio = temp;
	}
	
	

}

web/src/main/webapp/precios/editar.xhtml
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
	xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:p="http://primefaces.org/ui"
	template="/WEB-INF/templates/menu_template.xhtml">

	<ui:define name="tituloPagina">#{msgPrecios.bcPrecioCrear}</ui:define>

	<ui:define name="cuerpoPagina">
	#{beanPrecio.initObject()}
		<h:form id="form">
			<p:breadCrumb>
				<p:menuitem value="#{msgPrecios.bcInicio}"
					url="${request.contextPath}/" />
				<p:menuitem value="#{msgPrecios.bcPrecio}" url="#" />
				<p:menuitem value="#{msgPrecios.bcPrecioCrear}"
					url="${request.contextPath}/precios/crear.faces" />
			</p:breadCrumb>

		</h:form>

		<h:outputText escape="false" value="." />

		<h:form id="formMessage">
			<p:growl id="messages" showDetail="true" showSummary="true"
				for="msgGrowl" escape="false" />
		</h:form>

		<h:form id="formPrecio" style="justify-content: center;">
			<p:panelGrid id="panel" style="width: 80%;">
				<f:facet name="header">
					<p:row>
						<p:column colspan="2">
							<p:outputLabel>#{msgPrecios.tituloCrear}</p:outputLabel>
						</p:column>
					</p:row>
				</f:facet>



				<p:row>
					<p:column style="width: 20%;">
						<h:outputLabel for="producto" value="#{msgPrecios.producto}" />
					</p:column>

					<p:column style="width: 80%;'">
						<p:selectOneMenu id="producto"
							value="#{beanPrecio.idComboProducto}"
							style="width: 50%; line-height: 20px;" required="true"
							requiredMessage="#{msgPrecios.productoRequerido}">

							<f:selectItems value="#{beanPrecio.comboProducto}" />
							<f:ajax listener="#{beanPrecio.getComboListaPrecios}"
								render="listaPrecio" />

						</p:selectOneMenu>
						<p:message for="producto" style="width: 40%;" />
					</p:column>
				</p:row>

				<p:row>
					<p:column style="width: 20%;">
						<h:outputLabel for="listaPrecio" value="#{msgPrecios.listaPrecio}" />
					</p:column>

					<p:column style="width: 80%;'">
						<p:selectOneMenu id="listaPrecio"
							value="#{beanPrecio.idComboListaPrecio}"
							style="width: 50%; line-height: 20px;" required="true"
							requiredMessage="#{msgPrecios.listaPrecioRequerido}">

							<f:selectItems value="#{beanPrecio.listaPreciosCargada}" />

						</p:selectOneMenu>
						<p:message for="listaPrecio" style="width: 40%;" />
					</p:column>
				</p:row>

				<p:row>
					<p:column style="width: 20%;">
						<h:outputLabel for="valor" value="#{msgPrecios.valor}" />
					</p:column>

					<p:column style="width: 80%;'">
						<p:inputNumber id="valor" value="#{beanPrecio.objPrecio.valor}"
							required="true" style="width: 50%; line-height: 20px;"
							requiredMessage="#{msgPrecios.valorRequerido}" />
						<p:message for="valor" style="width: 40%;" />
					</p:column>
				</p:row>

				<f:facet name="footer">

					<p:row>
						<p:column style="width: 20%;">
						</p:column>

						<p:column style="width: 80%;display: flex;">
							<p:commandButton value="#{msgPrecios.btnCrear}" ajax="true"
								style="justify-content:center;"
								update="panel formMessage:messages"
								action="#{beanPrecio.btnCrearPrecio()}" />
						</p:column>
					</p:row>

				</f:facet>

			</p:panelGrid>

		</h:form>
	</ui:define>

</ui:composition>